<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>Source code</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="source: package: org.apache.commons.cli, class: OptionGroup">
<meta name="generator" content="javadoc/SourceToHTMLConverter">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body class="source-page">
<main role="main">
<div class="source-container">
<pre><span class="source-line-no">001</span><span id="line-1">/*</span>
<span class="source-line-no">002</span><span id="line-2">  Licensed to the Apache Software Foundation (ASF) under one or more</span>
<span class="source-line-no">003</span><span id="line-3">  contributor license agreements.  See the NOTICE file distributed with</span>
<span class="source-line-no">004</span><span id="line-4">  this work for additional information regarding copyright ownership.</span>
<span class="source-line-no">005</span><span id="line-5">  The ASF licenses this file to You under the Apache License, Version 2.0</span>
<span class="source-line-no">006</span><span id="line-6">  (the "License"); you may not use this file except in compliance with</span>
<span class="source-line-no">007</span><span id="line-7">  the License.  You may obtain a copy of the License at</span>
<span class="source-line-no">008</span><span id="line-8"></span>
<span class="source-line-no">009</span><span id="line-9">      http://www.apache.org/licenses/LICENSE-2.0</span>
<span class="source-line-no">010</span><span id="line-10"></span>
<span class="source-line-no">011</span><span id="line-11">  Unless required by applicable law or agreed to in writing, software</span>
<span class="source-line-no">012</span><span id="line-12">  distributed under the License is distributed on an "AS IS" BASIS,</span>
<span class="source-line-no">013</span><span id="line-13">  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span>
<span class="source-line-no">014</span><span id="line-14">  See the License for the specific language governing permissions and</span>
<span class="source-line-no">015</span><span id="line-15">  limitations under the License.</span>
<span class="source-line-no">016</span><span id="line-16"> */</span>
<span class="source-line-no">017</span><span id="line-17"></span>
<span class="source-line-no">018</span><span id="line-18">package org.apache.commons.cli;</span>
<span class="source-line-no">019</span><span id="line-19"></span>
<span class="source-line-no">020</span><span id="line-20">import java.io.Serializable;</span>
<span class="source-line-no">021</span><span id="line-21">import java.util.Collection;</span>
<span class="source-line-no">022</span><span id="line-22">import java.util.Iterator;</span>
<span class="source-line-no">023</span><span id="line-23">import java.util.LinkedHashMap;</span>
<span class="source-line-no">024</span><span id="line-24">import java.util.Map;</span>
<span class="source-line-no">025</span><span id="line-25"></span>
<span class="source-line-no">026</span><span id="line-26">/**</span>
<span class="source-line-no">027</span><span id="line-27"> * A group of mutually exclusive options.</span>
<span class="source-line-no">028</span><span id="line-28"> */</span>
<span class="source-line-no">029</span><span id="line-29">public class OptionGroup implements Serializable {</span>
<span class="source-line-no">030</span><span id="line-30">    /** The serial version UID. */</span>
<span class="source-line-no">031</span><span id="line-31">    private static final long serialVersionUID = 1L;</span>
<span class="source-line-no">032</span><span id="line-32"></span>
<span class="source-line-no">033</span><span id="line-33">    /** hold the options */</span>
<span class="source-line-no">034</span><span id="line-34">    private final Map&lt;String, Option&gt; optionMap = new LinkedHashMap&lt;&gt;();</span>
<span class="source-line-no">035</span><span id="line-35"></span>
<span class="source-line-no">036</span><span id="line-36">    /** The name of the selected option */</span>
<span class="source-line-no">037</span><span id="line-37">    private String selected;</span>
<span class="source-line-no">038</span><span id="line-38"></span>
<span class="source-line-no">039</span><span id="line-39">    /** specified whether this group is required */</span>
<span class="source-line-no">040</span><span id="line-40">    private boolean required;</span>
<span class="source-line-no">041</span><span id="line-41"></span>
<span class="source-line-no">042</span><span id="line-42">    /**</span>
<span class="source-line-no">043</span><span id="line-43">     * Add the specified {@code Option} to this group.</span>
<span class="source-line-no">044</span><span id="line-44">     *</span>
<span class="source-line-no">045</span><span id="line-45">     * @param option the option to add to this group</span>
<span class="source-line-no">046</span><span id="line-46">     * @return this option group with the option added</span>
<span class="source-line-no">047</span><span id="line-47">     */</span>
<span class="source-line-no">048</span><span id="line-48">    public OptionGroup addOption(final Option option) {</span>
<span class="source-line-no">049</span><span id="line-49">        // key - option name</span>
<span class="source-line-no">050</span><span id="line-50">        // value - the option</span>
<span class="source-line-no">051</span><span id="line-51">        optionMap.put(option.getKey(), option);</span>
<span class="source-line-no">052</span><span id="line-52"></span>
<span class="source-line-no">053</span><span id="line-53">        return this;</span>
<span class="source-line-no">054</span><span id="line-54">    }</span>
<span class="source-line-no">055</span><span id="line-55"></span>
<span class="source-line-no">056</span><span id="line-56">    /**</span>
<span class="source-line-no">057</span><span id="line-57">     * @return the names of the options in this group as a {@code Collection}</span>
<span class="source-line-no">058</span><span id="line-58">     */</span>
<span class="source-line-no">059</span><span id="line-59">    public Collection&lt;String&gt; getNames() {</span>
<span class="source-line-no">060</span><span id="line-60">        // the key set is the collection of names</span>
<span class="source-line-no">061</span><span id="line-61">        return optionMap.keySet();</span>
<span class="source-line-no">062</span><span id="line-62">    }</span>
<span class="source-line-no">063</span><span id="line-63"></span>
<span class="source-line-no">064</span><span id="line-64">    /**</span>
<span class="source-line-no">065</span><span id="line-65">     * @return the options in this group as a {@code Collection}</span>
<span class="source-line-no">066</span><span id="line-66">     */</span>
<span class="source-line-no">067</span><span id="line-67">    public Collection&lt;Option&gt; getOptions() {</span>
<span class="source-line-no">068</span><span id="line-68">        // the values are the collection of options</span>
<span class="source-line-no">069</span><span id="line-69">        return optionMap.values();</span>
<span class="source-line-no">070</span><span id="line-70">    }</span>
<span class="source-line-no">071</span><span id="line-71"></span>
<span class="source-line-no">072</span><span id="line-72">    /**</span>
<span class="source-line-no">073</span><span id="line-73">     * @return the selected option name</span>
<span class="source-line-no">074</span><span id="line-74">     */</span>
<span class="source-line-no">075</span><span id="line-75">    public String getSelected() {</span>
<span class="source-line-no">076</span><span id="line-76">        return selected;</span>
<span class="source-line-no">077</span><span id="line-77">    }</span>
<span class="source-line-no">078</span><span id="line-78"></span>
<span class="source-line-no">079</span><span id="line-79">    /**</span>
<span class="source-line-no">080</span><span id="line-80">     * Tests whether this option group is required.</span>
<span class="source-line-no">081</span><span id="line-81">     *</span>
<span class="source-line-no">082</span><span id="line-82">     * @return whether this option group is required</span>
<span class="source-line-no">083</span><span id="line-83">     */</span>
<span class="source-line-no">084</span><span id="line-84">    public boolean isRequired() {</span>
<span class="source-line-no">085</span><span id="line-85">        return required;</span>
<span class="source-line-no">086</span><span id="line-86">    }</span>
<span class="source-line-no">087</span><span id="line-87"></span>
<span class="source-line-no">088</span><span id="line-88">    /**</span>
<span class="source-line-no">089</span><span id="line-89">     * @param required specifies if this group is required</span>
<span class="source-line-no">090</span><span id="line-90">     */</span>
<span class="source-line-no">091</span><span id="line-91">    public void setRequired(final boolean required) {</span>
<span class="source-line-no">092</span><span id="line-92">        this.required = required;</span>
<span class="source-line-no">093</span><span id="line-93">    }</span>
<span class="source-line-no">094</span><span id="line-94"></span>
<span class="source-line-no">095</span><span id="line-95">    /**</span>
<span class="source-line-no">096</span><span id="line-96">     * Set the selected option of this group to {@code name}.</span>
<span class="source-line-no">097</span><span id="line-97">     *</span>
<span class="source-line-no">098</span><span id="line-98">     * @param option the option that is selected</span>
<span class="source-line-no">099</span><span id="line-99">     * @throws AlreadySelectedException if an option from this group has already been selected.</span>
<span class="source-line-no">100</span><span id="line-100">     */</span>
<span class="source-line-no">101</span><span id="line-101">    public void setSelected(final Option option) throws AlreadySelectedException {</span>
<span class="source-line-no">102</span><span id="line-102">        if (option == null) {</span>
<span class="source-line-no">103</span><span id="line-103">            // reset the option previously selected</span>
<span class="source-line-no">104</span><span id="line-104">            selected = null;</span>
<span class="source-line-no">105</span><span id="line-105">            return;</span>
<span class="source-line-no">106</span><span id="line-106">        }</span>
<span class="source-line-no">107</span><span id="line-107"></span>
<span class="source-line-no">108</span><span id="line-108">        // if no option has already been selected or the</span>
<span class="source-line-no">109</span><span id="line-109">        // same option is being reselected then set the</span>
<span class="source-line-no">110</span><span id="line-110">        // selected member variable</span>
<span class="source-line-no">111</span><span id="line-111">        if (selected != null &amp;&amp; !selected.equals(option.getKey())) {</span>
<span class="source-line-no">112</span><span id="line-112">            throw new AlreadySelectedException(this, option);</span>
<span class="source-line-no">113</span><span id="line-113">        }</span>
<span class="source-line-no">114</span><span id="line-114">        selected = option.getKey();</span>
<span class="source-line-no">115</span><span id="line-115">    }</span>
<span class="source-line-no">116</span><span id="line-116"></span>
<span class="source-line-no">117</span><span id="line-117">    /**</span>
<span class="source-line-no">118</span><span id="line-118">     * Returns the stringified version of this OptionGroup.</span>
<span class="source-line-no">119</span><span id="line-119">     *</span>
<span class="source-line-no">120</span><span id="line-120">     * @return the stringified representation of this group</span>
<span class="source-line-no">121</span><span id="line-121">     */</span>
<span class="source-line-no">122</span><span id="line-122">    @Override</span>
<span class="source-line-no">123</span><span id="line-123">    public String toString() {</span>
<span class="source-line-no">124</span><span id="line-124">        final StringBuilder buff = new StringBuilder();</span>
<span class="source-line-no">125</span><span id="line-125"></span>
<span class="source-line-no">126</span><span id="line-126">        final Iterator&lt;Option&gt; iter = getOptions().iterator();</span>
<span class="source-line-no">127</span><span id="line-127"></span>
<span class="source-line-no">128</span><span id="line-128">        buff.append("[");</span>
<span class="source-line-no">129</span><span id="line-129"></span>
<span class="source-line-no">130</span><span id="line-130">        while (iter.hasNext()) {</span>
<span class="source-line-no">131</span><span id="line-131">            final Option option = iter.next();</span>
<span class="source-line-no">132</span><span id="line-132"></span>
<span class="source-line-no">133</span><span id="line-133">            if (option.getOpt() != null) {</span>
<span class="source-line-no">134</span><span id="line-134">                buff.append("-");</span>
<span class="source-line-no">135</span><span id="line-135">                buff.append(option.getOpt());</span>
<span class="source-line-no">136</span><span id="line-136">            } else {</span>
<span class="source-line-no">137</span><span id="line-137">                buff.append("--");</span>
<span class="source-line-no">138</span><span id="line-138">                buff.append(option.getLongOpt());</span>
<span class="source-line-no">139</span><span id="line-139">            }</span>
<span class="source-line-no">140</span><span id="line-140"></span>
<span class="source-line-no">141</span><span id="line-141">            if (option.getDescription() != null) {</span>
<span class="source-line-no">142</span><span id="line-142">                buff.append(" ");</span>
<span class="source-line-no">143</span><span id="line-143">                buff.append(option.getDescription());</span>
<span class="source-line-no">144</span><span id="line-144">            }</span>
<span class="source-line-no">145</span><span id="line-145"></span>
<span class="source-line-no">146</span><span id="line-146">            if (iter.hasNext()) {</span>
<span class="source-line-no">147</span><span id="line-147">                buff.append(", ");</span>
<span class="source-line-no">148</span><span id="line-148">            }</span>
<span class="source-line-no">149</span><span id="line-149">        }</span>
<span class="source-line-no">150</span><span id="line-150"></span>
<span class="source-line-no">151</span><span id="line-151">        buff.append("]");</span>
<span class="source-line-no">152</span><span id="line-152"></span>
<span class="source-line-no">153</span><span id="line-153">        return buff.toString();</span>
<span class="source-line-no">154</span><span id="line-154">    }</span>
<span class="source-line-no">155</span><span id="line-155">}</span>




























































</pre>
</div>
</main>
</body>
</html>
